//Authors: 		@Samabam#8840
//				@Ynscription#6173
//
//Last Updated:	2018/08/06	(ISO date format)
//
//Instructions:	If you're updating this script it means I'm probably dead. Thank god for that. The concept is fairly simple.
//				By monitoring the Prince's coordinates we're able to create what I call 'virtual hitboxes.' I attempted to
//				place my VHBs in places that no sane person would skip using the current route.
//
//Notes: 		Shoutouts to Tocaloni1 and others for finding the coordinate addresses. Shoutouts to GrizzBear for helping me test.
//				Shoutouts to Ynscription for caring enough to refine & finish this script.


state("POP"){
//Some memory value that reliably changes when 'New Game' is pressed.
	int startValue : 0x006DB15C, 0x10, 0x48, 0x4, 0x44, 0x25C;

//Prince's position in terms of memory values.
	float xPos : 0x00699474, 0xC, 0x30;
	float yPos : 0x00699474, 0xC, 0x34;
	float zPos : 0x00699474, 0xC, 0x38;

//The Vizier's health where 0 is unharmed and 4 is dead.
	int vizierHealth : 0x0040E518, 0x6C, 0x18, 0x4, 0x44, 0x0;

//The prince's maxHealth
	int maxHealth : 0x006DB8F4, 0x4D4;
//The prince's currHealth
	int currHealth : 0x006DB500, 0x0;

//The prince maxSandTanks
	int maxSands : 0x006DB8F4, 0x0;
}

startup{
	//Settings
	//Hard Mode
	settings.Add("hardMode", false, "Activates Hard Mode: you have 1 hp and 1 sand tank.");

	//Int used to keep track of how many splits should have triggered by a given point.
	int split;

	//A simple flag to handle the fact that the Prince ends up on top of the tomb twice.
	bool hasDreamed;

}

init {
	//Function that determines the current split number
	vars.GetSplit = (Func<int, int>) ((lastSplit) => {
		//Each block is set to trigger when the Prince is in a specific location.

		//The Treasure Vaults
		if (lastSplit <= 0 &&
			current.zPos >= 23.0000 && current.zPos <= 23.0001 &&
			current.yPos >= 130.6470){
				return 1;
		}

		//The Sands of Time
		if (lastSplit <= 1 &&
			current.zPos >= 7.6053 	&& current.zPos <= 7.6055 &&
			current.yPos >= 62.9062 && current.yPos <= 62.9064){
				return 2;
		}

		//First Guest Room
		if (lastSplit <= 2  &&
			current.zPos >=  12.9993 && current.zPos <= 12.9995 &&
			current.yPos >=  42.1269 && current.yPos <= 42.1271){
				return 3;
		}

		//Torpedo Skip
		if (lastSplit <= 3  &&
			current.zPos >= -8.9586  && current.zPos <= -8.9584 &&
			current.yPos >=  39.5689 && current.yPos <= 39.5691){
				return 4;
		}

		//Exit Palace Defense
		if (lastSplit <= 4  &&
			current.zPos >= -39.0001 && current.zPos <= -38.9999 &&
			current.xPos >=  4 		 && current.xPos <=  8.4216){
				return 5;
		}

		//Start Dad Fight
		if (lastSplit <= 5  &&
			current.zPos >=  21.0061 && current.zPos <= 21.0063 &&
			current.xPos >=  6.7146  && current.xPos <= 6.7148){
				return 6;
		}

		//I'll Try to Find a Way In
		if (lastSplit <= 6  &&
			current.zPos >=  1.9998 && current.zPos <=  2 	&&
			current.xPos >= -7 		&& current.xPos <= -5.9 &&
			current.yPos >= -19 	&& current.yPos <= -17.9){
				return 7;
		}

		//I Found a Way In
		if (lastSplit <= 7  &&
			current.zPos >= -1.0001 && current.zPos <= -0.999 &&
			current.xPos >= -74 	&& current.xPos <= -71	  &&
			current.yPos >= -28 	&& current.yPos <= -23){
				return 8;
		}

		//The Warehouse
		if (lastSplit <= 8  &&
			current.zPos >= -31.0010 && current.zPos <= -30.9998 &&
			current.xPos >= -128 	 && current.xPos <= -125	 &&
			current.yPos >= -47.5 	 && current.yPos <= -42.5){
				return 9;
		}

		//Atop a Bird Cage
		if (lastSplit <= 9	 &&
			current.zPos >= -9 	 && current.zPos <= -8.8 &&
			current.yPos >= -23  && current.yPos <= -21  &&
			current.xPos >= -211 && current.xPos <= -208){
				return 10;
		}

		//Cliffs & Waterfalls
		if (lastSplit <= 10 &&
			current.zPos >= -42.6  && current.zPos <= -42.4 &&
			current.yPos >=  33.7  && current.yPos <=  35	&&
			current.xPos >= -233.6 && current.xPos <= -231.4){
				return 11;
		}

		//The Baths
		if (lastSplit <= 11 &&
			current.zPos >= -44   && current.zPos <= -43  &&
			current.yPos >=  52.5 && current.yPos <= 60.5 &&
			current.xPos >= -215  && current.xPos <= -208){
				return 12;
		}

		//Second Sword
		if (lastSplit <= 12 &&
			current.zPos >= -27.3 	&& current.zPos <= -27.2  &&
			current.yPos >=  81.009 && current.yPos <=  82    &&
			current.xPos >= -107 	&& current.xPos <= -106){
				return 13;
		}

		//Daybreak
		if (lastSplit <= 13 &&
			current.zPos >= -56.6 	&& current.zPos <= -54	  &&
			current.yPos >=  192.4  && current.yPos <=  197.6 &&
			current.xPos >= -76 	&& current.xPos <= -70){
				return 14;
		}

		//Farah Tower
		if(lastSplit <= 14  &&
			current.zPos >= -35.6 && current.zPos <= -35.5 &&
			current.yPos >=  232  && current.yPos <=  237  &&
			current.xPos >= -267  && current.xPos <= -262){
				return 15;
		}

		//A Broken Bridge
		if(lastSplit <= 15	 &&
			current.zPos >= -13.6 && current.zPos <= -13.4 &&
			current.yPos >=  159  && current.yPos <=  167  &&
			current.xPos >= -265  && current.xPos <= -257){
				return 16;
		}

		//The Caves
		if (lastSplit <= 16 &&
			current.zPos >= -56.1  && current.zPos <= -55.9  &&
			current.yPos <=  113.5 &&
			current.xPos >= -303   && current.xPos <= -297.5){
				return 17;
		}

		//Bottom Half of Caves
		if (lastSplit <= 17 &&
			current.zPos >= -121  && current.zPos <= -118 &&
			current.yPos >=  79.5 && current.yPos <=  83  &&
			current.xPos >= -242  && current.xPos <= -240.5){
				return 18;
		}

		//An Underground Reservoir
		if (lastSplit <= 18 &&
			current.zPos >= -154.1  && current.zPos <= -153.9 &&
			current.yPos >= -9 		&& current.yPos <= -7	  &&
			current.xPos >= -121 	&& current.xPos <= -110){
				return 19;
		}

		//The Hall of Learning
		if (lastSplit <= 19 &&
			current.zPos >= -24.1 && current.zPos <= -23.9 &&
			current.yPos >=  161  && current.yPos <=  163  &&
			current.xPos >=  73   && current.xPos <=  79){
				return 20;
		}

		//The Observatory
		if (lastSplit <= 20 &&
			current.zPos >= -26.6 && current.zPos <= -26.3 &&
			current.yPos >=  190  && current.yPos <=  192  &&
			current.xPos >=  137  && current.xPos <=  141){
				return 21;
		}

		//The Hall of Learning Courtyards
		if (lastSplit <= 21 &&
			current.zPos >= -29.4 && current.zPos <= -29.2  &&
			current.yPos >=  120  && current.yPos <=  123.5 &&
			current.xPos >=  73   && current.xPos <=  77){
				return 22;
		}

		//Exiting The Hall of Learning Courtyards
		if (lastSplit <= 22 &&
			current.zPos >= -27.1 && current.zPos <= -26.9 &&
			current.yPos >=  90   && current.yPos <=  95.7 &&
			current.xPos >=  72   && current.xPos <=  77){
				return 23;
		}

		//The Prison
		if (lastSplit <= 23 &&
			current.zPos >= -17.5 && current.zPos <= -17.3	&&
			current.yPos >= -23.5 && current.yPos <= -17	&&
			current.xPos >=  190  && current.xPos <=  192){
				return 24;
		}

		//The Torture Chamber
		if (lastSplit <= 24 &&
			current.zPos >= -119.1  && current.zPos <= -118.9 &&
			current.yPos >= -39 	&& current.yPos <= -37.5  &&
			current.xPos >=  187.5  && current.xPos <=  192.5){
				return 25;
		}

		//---------------------------------------------------------
		////Exit The Torture Chamber (I have deprecated this split)
		//if(lastSplit <= ){
		//if(current.zPos >= -33.5 && current.zPos <= -33.3){
		//if(current.yPos >= -49.5 && current.yPos <= -49.3){
		//if(current.xPos >= 189.5 && current.xPos <= 190.5){
		//return ;
		//}}}}
		//---------------------------------------------------------

		//Enter the Elevator
		if (lastSplit <= 25 &&
			current.zPos >= -33.6 && current.zPos <= -33.4 &&
			current.yPos >= -47.5 && current.yPos <= -42.5 &&
			current.xPos >=  72   && current.xPos <=  74){
				return 26;
		}

		//The Tomb Cutscene
		if (lastSplit <= 26 &&
			current.zPos >= -56 && current.zPos <= -54 &&
			current.yPos >= -11 && current.yPos <= -10 &&
			current.xPos >=  99 && current.xPos <=  101){
				return 27;
		}

		//---------------------------------------------------------------------------------------------

		//Flagging hasDreamed so that 'The Tomb' split doesn't trigger early during the prior cutscene.
		if (lastSplit <= 	 27   && !vars.hasDreamed		&&
			current.zPos >= -74.9 && current.zPos <= -74.7	&&
			current.yPos >= -25.1 && current.yPos <= -24.9	&&
			current.xPos >=  95.8 && current.xPos <=  96){
				vars.hasDreamed = true;
				print("hasDreamed flag is equal to: " + vars.hasDreamed.ToString());
		}

		//---------------------------------------------------------------------------------------------

		//The Tomb
		if (lastSplit   <=  27 && vars.hasDreamed		  &&
			current.zPos >= -68 && current.zPos    <= -67 &&
			current.yPos >= -12 && current.yPos    <= -10 &&
			current.xPos >=  99 && current.xPos    <=  101){
				return 28;
		}

		//The Tower of Dawn
		if (lastSplit <= 28 &&
			current.zPos >= -32  && current.zPos <= -30 &&
			current.yPos >= -50  && current.yPos <= -39 &&
			current.xPos >= 35.5 && current.xPos <= 35.7){
				return 29;
		}

		//The Setting Sun
		if (lastSplit <= 29 &&
			current.zPos >=  30 && current.zPos <=  32 &&
			current.yPos >= -58 && current.yPos <= -57 &&
			current.xPos >=  60 && current.xPos <=  61){
				return 30;
		}

		//Honor and Glory
		if (lastSplit <= 30 &&
			current.zPos >=  89   && current.zPos <= 90	   &&
			current.yPos >= -60.3 && current.yPos <= -59.7 &&
			current.xPos >=  81   && current.xPos <= 82){
				return 31;
		}

		//The Grand Rewind
		if (lastSplit <= 31 &&
			current.zPos >=  0 	 && current.zPos <= 1	&&
			current.yPos >=  190 && current.yPos <= 194 &&
			current.xPos >=  659 && current.xPos <= 660){
				return 32;
		}

		//The end
		//Vizier skip
		if (lastSplit == 32 &&
			current.zPos >=  8.5 	 && current.zPos <= 14	&&
			current.yPos >=  209.5 && current.yPos <= 215.2 &&
			current.xPos >=  656.5 && current.xPos <= 663.1) {
			return 33;
		}

		//Killing vizier
		if (lastSplit == 32 && current.vizierHealth == 4){
			return 33;
		}

		return -1;
	});

	//Function that skips a split
	vars.SkipSplit = (Func<int>)(() => {
		timer.CurrentSplit.SplitTime = default(Time);
        timer.CurrentSplitIndex++;
        timer.Run.HasChanged = true;
		return 0;
	});

}

start{
	vars.gameStarted = false;
	//Detecting if the Prince is on the starting balcony and if NewGame has been pressed.
	if (current.xPos >= -103.3 	&& current.xPos <= -103.2 &&
		current.zPos >=  1.3 	&& current.zPos <=  1.4 &&
		current.yPos >= -5.0 	&& current.yPos <= -4.0 &&
		current.startValue == 1){
			//Initializing variables if the game has started
			vars.gameStarted = true;
			vars.split = 0;
			vars.hasDreamed = false;
			return true;
	}
}

split{
	//Code for HardMode
	if (settings["hardMode"] && vars.gameStarted) {
		if (current.maxHealth > 5) {
			//The prince's max health for writing
			IntPtr maxHealthW = (IntPtr) (new DeepPointer (0x006DB8F4)).Deref<uint>(game, 0);
			//The prince's health for writing
			IntPtr currHealthW = (IntPtr) (new DeepPointer (0x006DB8F4)).Deref<uint>(game, 0);

			//Write 5 to maxHp and currHP
			game.WriteBytes (maxHealthW + 0x4D4, new byte [] {0x01, 0x00, 0x00, 0x00});
			game.WriteBytes (currHealthW - 0xB88, new byte [] {0x01, 0x00, 0x00, 0x00});
		}
		if (current.maxSands > 1) {
			//The prince's max sand tanks for writing
			IntPtr maxSandsW = (IntPtr) (new DeepPointer (0x006DB8F4)).Deref<uint>(game, 0);

			//Write 1 to maxSands
			game.WriteBytes (maxSandsW, new byte [] {0x01, 0x00, 0x00, 0x00});
		}
	}

	//Get the current split (-1 if we haven't hit a split trigger this update)
	int currSplit = vars.GetSplit(vars.split);

	//Check if we have hit a split trigger
	if (currSplit >= 0) {

		//Difference between last split and current split
		int diff = currSplit - vars.split;

		//We have missed a split at some point
		if (diff > 1) {
			//We must skip (diff - 1) splits that we have missed
			for (int i = 1; i < diff; i++) {
				vars.SkipSplit();
			}
		}

		//Split normally
		vars.split = currSplit;
		return true;

	}

}
